/*
 * Copyright 2006 Takahiro Nakamura.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package woolpack.factory;

import woolpack.fn.Fn;

/**
 * {@link Class#newInstance()}を使用するオブジェクトファクトリです。
 * @author nakamura
 *
 * @param <R>
 */
public class NewInstanceFactory<R> implements Fn<Object, R> {
	private Class<R> clazz;
	
	public NewInstanceFactory(final Class<R> clazz) {
		this.clazz = clazz;
	}

	public R exec(final Object c) {
		try {
			return clazz.newInstance();
		} catch (final InstantiationException e) {
			throw new IllegalStateException(e);
		} catch (final IllegalAccessException e) {
			throw new IllegalStateException(e);
		}
	}

	public Class<R> getClazz() {
		return clazz;
	}
	public void setClazz(final Class<R> clazz) {
		this.clazz = clazz;
	}
}
